// Interface Elements header: IEElement.h
// Last modified 16 Feb 1997
// (c) 1997 Attila Mezei
// Do not modify this file!


#ifndef _IEELEMENT_H_
#define _IEELEMENT_H_


// export one C function:
#pragma export on
extern "C" void *message_port(BMessage *message);
#pragma export reset


// MESSAGE CONSTANTS:

// add-ons can implement in message_port():
#define IE_INIT 'Init'
#define IE_EXIT 'Exit'
#define IE_INSTANTIATE_BVIEW 'Inst'
#define IE_INSTANTIATE_PALETTE_BVIEW 'InsP'
#define IE_EDIT 'Edit'
#define IE_GET_OPTIONS 'Get?'

// add-ons controlling a variable may implement in their MessageReceived():
#define IE_SET_VARIABLE 'Set!'
#define IE_VARIABLE_TO_VIEW 'v2vu'
#define IE_VIEW_TO_VARIABLE 'vu2v'
#define IE_ALL_VIEWS_ATTACHED 'IEaa'


// add-ons which can generate themselves may implement in message_port():
#define IE_GENERATE 'Gen!'

// strip unnecessary information for final software release. Received in message_port():
#define IE_STRIP 'Strp'


// what data of return message can be:
	// either GUI element without inspector:
#define IE_GUI_ELEMENT 'Lmnt'
	// or GUI element with inspector:
#define IE_GUI_ELEMENT_INSPECTOR 'Insp'


// this is posted when the add-on window is closed:
#define IE_WINDOW_CLOSED 'IEwc'
// this can be posted when the user changes a value, so that the view and its encapsulating parent is updated
#define IE_UPDATE_VIEW 'IEuv'


#endif